W(1)

NAME
w - display who is logged in and what they are doing

SYNOPSIS
w [-dhin] [-M core] [-N system] [user ...]

DESCRIPTION
The w utility prints a summary of the current activity on the system, including what each user is doing. The first line displays the current time of day, how long the system has been running, the number of users logged into the system, and the load averages. The load average numbers give the number of jobs in the run queue averaged over 1, 5 and 15 minutes.

The fields output are the user's login name, the name of the terminal the user is on, the host from which the user is logged in, the time the user logged on, the time since the user last typed anything, and the name and arguments of the current process.

The options are as follows:

-d  dumps out the entire process list on a per controlling tty basis, instead of just the top level process.

-h  Suppress the heading.

-i  Output is sorted by idle time.

-M  Extract values associated with the name list from the specified core instead of the default /dev/kmem.

-N  Extract the name list from the specified system instead of the default /boot/kernel/kernel.

-n  Do not attempt to resolve network addresses (normally w interprets addresses and attempts to display them as names).

If one or more user names are specified, the output is restricted to those users.

FILES
/var/run/utmp
    list of users on the system

COMPATIBILITY
The -f, -l, -s, and -w flags are no longer supported.

SEE ALSO
finger(1), ps(1), uptime(1), who(1)

HISTORY
The w command appeared in 3.0BSD.

BUGS
The notion of the “current process” is muddy. The current algorithm is “ the highest numbered process on the terminal that is not ignoring interrupts, or, if there is none, the highest numbered process on the terminal ”. This fails, for example, in critical sections of programs like the shell and editor, or when faulty programs running in the background fork and fail to ignore interrupts. (In cases where no process can be found, w prints ‘-’.)

The CPU time is only an estimate, in particular, if someone leaves a background process running after logging out, the person currently on that terminal is “charged” with the time.

Background processes are not shown, even though they account for much of the load on the system.

Sometimes processes, typically those in the background, are printed with null or garbaged arguments. In these cases, the name of the command is printed in parentheses.

The w utility does not know about the new conventions for detection of background jobs. It will sometimes find a background job instead of the right one.